#include <system.h>
#include <irq.h>
#include <kb.h>

unsigned char inportb (unsigned short _port)
{
	unsigned char rv;
	__asm__ __volatile__ ("inb %1, %0" : "=a" (rv) : "dN" (_port));
	return rv;
}

void outportb (unsigned short _port, unsigned char _data)
{
	__asm__ __volatile__ ("outb %1, %0" : : "dN" (_port), "a" (_data));
}

void main()
{
	//init_video();
	//puts("GDT install\n");
	
	
	gdt_install();
	
	//puts("IDT install\n");
	idt_install();
	
	//puts("ISR install\n");
	isrs_install();
	
	//puts("IRQ install\n");
	irq_install();
	
	//puts("Keyboard install\n");
	keyboard_install();
	timer_install();
	
	//puts("Enabling Interrupts\n");
	init_video();
	
	//__asm__ __volatile__ ("hlt");
	__asm__ __volatile__ ("sti");

	//int i=6/0;
	//    i = 10 / 0;
//    putch(i);

	for (;;);
}
