#include <system.h>
#include <string.h>

unsigned char* txtmemptr;
int attrib=0x0F;
int cur_x=0;
int cur_y=0;

void scroll(void)
{
	unsigned int blank=0x20 | (attrib << 8);
	unsigned int temp;

	if(cur_y>=25)
	{
		temp=cur_y-25+1;
		memcpy(txtmemptr,txtmemptr+temp*80,(25-temp)*80*2);

		memsetw((unsigned short*)(txtmemptr+(25-temp)*80),blank,80);
		cur_y=25-1;
	}
}

void move_cur(void)
{
	unsigned temp;
	temp = cur_y * 80 + cur_x;
	/* This sends a command to indicies 14 and 15 in the
	 *  CRT Control Register of the VGA controller. These
	 *  are the high and low bytes of the index that show
	 *  where the hardware cursor is to be 'blinking'. To
	 *  learn more, you should look up some VGA specific
	 *  programming documents. A great start to graphics:
	 *  http://www.brackeen.com/home/vga */
	outportb(0x3D4, 14);
	outportb(0x3D5, temp >> 8);
	outportb(0x3D4, 15);
	outportb(0x3D5, temp);
}

void cls()
{
	unsigned int blank=0x20 | (attrib << 8);
	int i;

	for(i = 0; i < 25; i++)
	{
		memsetw ((unsigned short*)(txtmemptr + i * 80), blank, 80);
	}

	cur_x = 0;
	cur_y = 0;
	move_cur();
}

void putch(unsigned char c)
{
	unsigned short *ptr;
	unsigned short attr=attrib<<4;	

	if(c==0x08)
	{
		if(cur_x>0)
		{
			cur_x--;
		}
	}
	else if(c==0x09)
	{
		cur_x = (cur_x + 8) & ~(8 - 1);
			
	}
	else if(c=='\n')
	{
		cur_x=0;
		cur_y++;	
	}
	else if(c=='\r')
	{
		cur_x=0;		
	}
	else if(c>=' ')
	{
		ptr=(unsigned short*)(txtmemptr+(cur_y*80+cur_x));
		*ptr=c|attr;
		cur_x++;
	}

	if(cur_x>80)
	{
		cur_x=0;
		cur_y++;
	}

	scroll();
	move_cur();
}

void puts(unsigned char *str)
{
	int i;

	for(i=0;i<strlen((char*)str);i++)
	{
		putch(str[i]);
	}
}

void settextcolor(unsigned char forecolor, unsigned char backcolor)
{
	attrib=(backcolor<<4) | (forecolor & 0x0F);	
}

void init_video()
{
	txtmemptr=(unsigned char*)0xB8000;
	cls();
}
